package basic;

import java.io.InputStream;

public class CONSOLEStatement extends Statement  {

  private int ls;
  private int ln;
  private int cs;
  private int cn;

  public CONSOLEStatement(LexicalTokenizer lt) throws BASICSyntaxError {
    super("CONSOLE", true, true, true);

    ls = -1;
    ln = -1;
    cs = -1;
    cn = -1;

    parse(lt);
  }

  public Statement doit(Program pgm, InputStream in, BasicPrintStream out) throws BASICRuntimeError {
    //TODO:  basic.StatementInterface \bh;

    return pgm.nextStatement(this);
  }

  public String unparse() {
    return "CONSOLE";
  }

  public void parse(LexicalTokenizer lt) throws BASICSyntaxError {

    Token[] token = super.parseTokens(lt);

    if (token.length == 0) {
      // reset
    } else if (token.length == 7 && isValue(token[0]) && isComma(token[1]) && isValue(token[2]) && isComma(token[3]) && isValue(token[4]) && isComma(token[5]) && isValue
        (token[6])) {
      ls = (int)token[0].numValue();
      ln = (int)token[2].numValue();
      cs = (int)token[4].numValue();
      cn = (int)token[6].numValue();
    } else if (token.length == 3 && isValue(token[0]) && isComma(token[1]) && isValue(token[2])) {
      ls = (int)token[0].numValue();
      ln = (int)token[2].numValue();
    } else {
      throw new BASICSyntaxError();
    }
  }
}
