package basic;

import java.io.*;

import jp.gr.java_conf.sol.basic.mz700.*;
public class SAVEStatement extends Statement {

  private BasicString programName;

  public SAVEStatement(LexicalTokenizer lt) throws BASICSyntaxError {
    super("SAVE", true, false, true);

    parse(lt);
  }

  public Statement doit(Program pgm, InputStream in, BasicPrintStream out) throws BASICRuntimeError {

    out.write((char)0x7f);
    out.write(" RECORD.PLAY\n");

    try {
      String fileName = Tape.getTape4Save();
      if (fileName == null){
        throw new BASICRuntimeError("FILE NOT FOUND.\n");
      }

      BufferedOutputStream fileStream = new BufferedOutputStream(new FileOutputStream(fileName));

      BasicPrintStream pp = new BasicPrintStream(fileStream, null);

      BasicString savingName = programName;
      if (savingName == null) {
        savingName = new BasicString("");
      }

      out.write("WRITING   \"");
      out.write(savingName);
      out.write("\"\n");

      pgm.list(pp);
      pp.flush();

      fileStream.flush();
      fileStream.close();

    } catch (IOException ex) {
      throw new BASICRuntimeError("I/O ERORR");
    }

    return pgm.nextStatement(this);
  }

  public String unparse() {

    if (programName == null) {
      return "SAVE";
    } else {
      return "SAVE" + programName.getAsciiString();
    }
  }

  public void parse(LexicalTokenizer lt) throws BASICSyntaxError {

    Token t = lt.nextToken();
    if (t == null || t.typeNum() == Token.EOL) {
      return;
    } else if (t.typeNum() == Token.STRING) {
      programName = t.stringValue();
    } else {
      throw new BASICSyntaxError();
    }
  }

}
