package jp.gr.java_conf.sol.basic;

import java.util.*;

public abstract class KeyBoard {

  public static final int KEYBOARD_NORMAL     = 0;
  public static final int KEYBOARD_GRAPH      = 1;
  public static final int KEYBOARD_KANA       = 2;
  public static final int KEYBOARD_KANA_SHIFT = 3;
  public static final int KEYBOARD_HIRAKANA   = 4;
  public static final int KEYBOARD_HIRAKANA_SHIFT   = 5;

  private Hashtable table;

  public KeyBoard() {

    table = new Hashtable();

    int[][] array = getKeyboardSetting();

    for(int i=0; i<array.length; i++) {
      int key = array[i][0];
      table.put(new Integer(key), array[i]);
    }
  }

  public int getKeyCode(int code, int mode) throws ArrayIndexOutOfBoundsException {
  
    int keyCode = 0;

    int[] array = (int[])table.get(new Integer(code));
    if (array != null) {
      keyCode = array[mode];
    }

    return keyCode;
  }

  public abstract int[][] getKeyboardSetting();
} 