package jp.gr.java_conf.sol.basic.mz700;

import java.awt.*;
import basic.*;
import jp.gr.java_conf.sol.basic.*;

public class MZ700Character extends CustomCharacter {

  public static final int COLOR_BLACK   = 0;
  public static final int COLOR_BLUE    = 1;
  public static final int COLOR_RED     = 2;
  public static final int COLOR_MAGENDA = 3;
  public static final int COLOR_GREEN   = 4;
  public static final int COLOR_SKYBLUE = 5;
  public static final int COLOR_YELLOW  = 6;
  public static final int COLOR_WHITE   = 7;

  private static final Object[][] colorTable = {
    {new Integer(0xff000000), Color.black},         // 0 black
    {new Integer(0xff0000ff), Color.blue },         // 1 blue
    {new Integer(0xffff0000), Color.red},           // 2 red
    {new Integer(0xffff00ff), Color.magenta},       // 3 magenda
    {new Integer(0xff00ff00), Color.green},         // 4 green
    {new Integer(0xff00ffff), new Color(0,255,255)},// 5 skyblue
    {new Integer(0xffffff00), Color.yellow},        // 6 yellow
    {new Integer(0xffffffff), Color.white},         // 7 white
  };

  private int page;

  private int foreColorIndex;
  private int backColorIndex;

  /*
  private Color foreColor;
  private Color backColor;
  private int foreRGB;
  private int backRGB;
  */
  public MZ700Character(int chrCode, int page, int fgColorIndex, int bgColorIndex) {
    super(chrCode);
    setPage(page);
    setForeColorIndex(fgColorIndex);
    setBackColorIndex(bgColorIndex);
  }

  public void setPage(int v) {
    this.page = v;
  }
  public int getPage() {
    return this.page;
  }
  public String toString() {
    return "jp.gr.java_conf.sol.basic.MZ700Character["+getCode()+","+getPage()+"]";
  }

  public int hashCode() {
    return getCode() ^ (page*37) ^ (foreColorIndex*43) ^ (backColorIndex*47);
  }

  public static Color getColor(int number) {
    return (Color)colorTable[number][1];
  }

  public static int getRGB(int number) {

    Integer intObject = (Integer)colorTable[number][0];

    return intObject.intValue();
  }

  public static int getColorIndex(Color c) {

    if (c.equals(Color.black)) {
      return COLOR_BLACK;
    } else if (c.equals(Color.blue)) {
      return COLOR_BLUE;
    } else if (c.equals(Color.red)) {
      return COLOR_RED;
    }else if (c.equals(Color.magenta)) {
      return COLOR_MAGENDA;
    }else if (c.equals(Color.green)) {
      return COLOR_GREEN;
    }else if (c.equals(new Color(0,255,255))) {
      return COLOR_SKYBLUE;
    }else if (c.equals(Color.yellow)) {
      return COLOR_YELLOW;
    }else if (c.equals(Color.white)) {
      return COLOR_WHITE;
    }
    return COLOR_WHITE;
  }

  public void setForeColorIndex(int newForeColorIndex) {
    foreColorIndex = newForeColorIndex;
  }

  public int getForeColorIndex() {
    return foreColorIndex;
  }

  public void setBackColorIndex(int newBackColorIndex) {
    backColorIndex = newBackColorIndex;
  }

  public int getBackColorIndex() {
    return backColorIndex;
  }




}

