package jp.gr.java_conf.sol.basic.mz700;

import java.io.*;
import java.net.*;

import basic.*;

public class Tape {

  static String tape4Load;
  static String tape4Save;
  static URL tape4LoadURL;

  public static InputStream getTape4Load(BasicString fileName) throws IOException {

    InputStream is = null;
    boolean mzt = false;

    try {
      if (tape4Load != null) {
        is = new FileInputStream(tape4Load);
      } else if (tape4LoadURL != null) {
        URLConnection uc = tape4LoadURL.openConnection();
        is = uc.getInputStream();
      } else {
        // no tape
        throw new IOException("tape is null");
      }
    }catch (Exception ex) {
      ex.printStackTrace();
    }

    if (isMZT(tape4Load) || (tape4LoadURL != null && isMZT(tape4LoadURL.toString()))) {

      is = new CVSBasicStream(is);

      //  set fileName 
      MZTHeader header = ((CVSBasicStream)is).getHeader();
      fileName.setData(header.getFileName().getData());
    }

    return is;
  }

  private static boolean isMZT(String name) {

    boolean answer = false;

    if (name == null) {
      return false;
    }

    if (name.endsWith(".mzt") || name.endsWith(".MZT")) {
      answer = true;
    }

    return answer;
  }


  public static void setTape4Load(String str) {
    tape4Load = str;
    tape4LoadURL = null;
  }
  public static void setTape4Load(URL str) {
    tape4LoadURL = str;
    tape4Load = null;
  }

  public static void setTape4Save(String newTape4Save) {
    tape4Save = newTape4Save;
  }

  public static String getTape4Save() {
    return tape4Save;
  }
}
 
